<?
function readnames($path)
{
	global $config;
	$result[files] = array();
	$result[dirs] = array();
	$i_file = 0;
	$i_dir = 0;
	$opendir_Data = opendir($path);

	while(false != ($filename = readdir($opendir_Data)))
	{
		if(true == is_dir($path.'/'.$filename))
		{
			// directory
			if('.' != $filename && '..' != $filename)
			{
				$result[dirs][$i_dir] = $filename;
				$i_dir++;
			}
		}
		else
		{
			// file
			if('.' != substr($filename,0,1))	// hide hidden files
			{
				filename_to_file($result[files][$i_file],$filename);
				$i_file++;
			}
		}

	}
	closedir($opendir_Data);

	sort($result[dirs]);
	usort($result[files],'sort_files');
	return $result;
}
function filename_to_file(&$result,$filename)
{
	$result[extension] = strtolower(substr($filename,strrpos($filename,'.')+1));
	$result[totalname] = $filename;
}
function sort_files($x,$y)
{
	if(($result = strcmp($x[extension],$y[extension])) != 0)	{return $result;}
	else	{return strcasecmp($x[totalname],$y[totalname]);}
}

function print_dirs(&$result)
{
	global $var;
	foreach($result[dirs] as $cur)	{echo "<a href='$var[url_current]/$cur'>$cur</a><br />";}

}
function print_files(&$result)
{
	global $config;
	global $var;
	print '<table>';
	foreach($result[files] as $cur)
	{
		print '<tr><td>';
		echo "$cur[totalname]&nbsp;<a href='$config[url_root]/view.php?filename=$cur[totalname]&amp;paths=$var[paths]'>view</a>&nbsp;&nbsp;";
		echo "<a href='$var[url_data_current]/$cur[totalname]'>download</a>";
		print '</td><td>';
		print_file_extension($cur);
		print '</td></tr>';
	}
	print '</table>';
}
function print_nav()
{
	global $config;
	global $var;

	if('.' == $var[paths])
	{
		$nav = array('.');
	}
	else
	{
		$var[paths] = './'.$var[paths];
		$nav = explode('/',$var[paths]);
		for($i=sizeof($nav)-1;$i>0;$i--)
		{
			for($j=$i-1;$j>=0;$j--)
			{
				$nav[$i] = $nav[$j].'/'.$nav[$i];
			}
		}
	}
	foreach($nav as $cur)
	{
		$name = substr($cur,strrpos($cur,'/')+1);
		if('' == $name)
		{
			$name = 'Top';
		}
		echo "<a href='$config[url_root]/$cur'>$name</a>&nbsp;&gt;&nbsp;";
	}
}
function get_url_upper(&$url)
{
	$result[url] = substr($url,0,strrpos($url,'/'));

	if('.' == $result[url])	{$result[name] = 'Top';}
	else	{$result[name] = substr($result[url],strrpos($result[url],'/')+1);}

	return $result;
}
function get_now_name_long()
{
	global $var;
	global $config;
	if('.' == $var[paths])	{return $config[sitename].' Root';}
	else	{return $var[paths];}
}
function get_now_name()
{
	if(0 < strrpos(get_now_name_long(),'/'))
	{
		return substr(get_now_name_long(),strrpos(get_now_name_long(),'/')+1);
	}
	else
	{
		return get_now_name_long();
	}
}
function print_file_extension(&$file)
{
	global $var;
	switch($file[extension])
	{
		// GIF, JPG, PNG, SWF, SWC, PSD, TIFF, BMP, IFF, JP2, JPX, JB2, JPC, XBM, or WBMP
		case 'bmp' :
		case 'gif' :
		//case 'iff' :
		//case 'jp2' :
		case 'jpg' :
		//case 'jpx' :
		case 'png' :
		case 'xbm' :			
		//case 'wbmp' :
			list($width,$height,$type,$attr) = getimagesize($var[path_current].'/'.$file[totalname]);
			//echo "<img src='$var[url_data_current]/$file[totalname]' $attr title='$file[totalname] ($width".'x'."$height)' alt='$file[totalname]' /><br />";
			echo "<img src='$var[url_data_current]/$file[totalname]' height='50' title='$file[totalname] ($width".'x'."$height)' alt='$file[totalname]' /><br />";
			break;
		case 'psd' :
		case 'tiff' :
			list($width,$height,$type,$attr) = getimagesize($var[path_current].'/'.$file[totalname]);
			print $width.'x'.$height.' - No Preview';
			break;
		case 'swf' :
			break;
		case 'php' :
			print 'No Preview';
			break;
		default :
			print 'No Support';
			break;
	}
}
function print_view(&$file)
{
	global $config;
	global $var;
	switch($file[extension])
	{
		// GIF, JPG, PNG, SWF, SWC, PSD, TIFF, BMP, IFF, JP2, JPX, JB2, JPC, XBM, or WBMP
		case 'bmp' :
		case 'gif' :
		//case 'iff' :
		//case 'jp2' :
		case 'jpg' :
		//case 'jpx' :
		case 'png' :
		case 'xbm' :			
		//case 'wbmp' :
			list($width,$height,$type,$attr) = getimagesize($var[path_current].'/'.$file[totalname]);
			echo "<img src='$var[url_data_current]/$file[totalname]' $attr title='$file[totalname] ($width".'x'."$height)' alt='$file[totalname]' /><br />";
			break;
		case 'psd' :
		case 'tiff' :
			list($width,$height,$type,$attr) = getimagesize($var[path_current].'/'.$file[totalname]);
			print $width.'x'.$height.' - No Preview';
			break;
		case 'swf' :
			print_html_object_for_flash($file);
			break;
		case 'php' :
			//highlight_file($var[path_current].'/'.$file[totalname]);	// it works, but not xhtml.. so comment out!
			$result = file_get_contents($var[path_current].'/'.$file[totalname]);
			$result = str_replace('<','&lt;',$result);	// <? is woking like <!-- even in <pre>.. so change it!
			$result = str_replace('>','&gt;',$result);
			//$result = str_replace(' ','&nbsp;',$result);	// may be useles.. (because using <pre>
			print '<div class=bb><pre>'.$result.'</pre></div>';
			break;
		default :
			print 'No Support';
			break;
	}
}
function print_html_object_for_flash(&$file)
{
	global $var;
	$shortfilename = substr($file[totalname],0,strpos($file[totalname],'.'));
	$pathfilename = $var[url_data_current].'/'.$file[totalname];
	list($width,$height,$type,$attr) = getimagesize($var[path_current].'/'.$file[totalname]);
	print 
<<<PRT
	<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0"  type="application/x-shockwave-flash">
	<param name="filename" value="=$pathfilename" />
	<param name="movie" value="=$pathfilename" />
	<param name="pluginspage" value="http://www.macromedia.com/go/getflashplayer" />
	<param name="quality" value="high" />
	<param name="src" value="$pathfilename" />
	<param name="width" value="$width" />
	<param name="height" value="$height" />

</object>
PRT;
	print "It Doesn't Work :(";
}
?>
